<template>
  <b-container
    class="userContent d-flex align-items-center justify-content-center"
  >
    <div
      class="w-100 mt-4 d-flex flex-column align-items-center justify-content-center mb-4"
    >
      <dd>Sure Delete This {{ getUser.username }} User?</dd>
      <div
        v-if="!successfulyDeleted"
        class="w-25 d-flex flex-row align-items-center justify-content-between mt-5"
      >
        <b-button
          @click="handleDelete(getUser.id)"
          variant="danger border border-warning border-2 "
          >Confirm</b-button
        ><b-button
          @click="cancelDelete()"
          variant="primary border border-warning border-2"
          >Cancel</b-button
        >
      </div>
      <h4 v-if="successfulyDeleted" class="mt-4">User Successfully Deleted</h4>
    </div>
  </b-container>
</template>

<script>
import axios from "@/utilis/axiosInstance";

export default {
  name: "DeleteUser",
  data() {
    return {
      id: this.$route.params.id,
      successfulyDeleted: false,
    };
  },
  async created() {
    try {
      await this.$store.dispatch("LOAD_USER", this.id);
    } catch (err) {
      throw new Error(err);
    }
  },
  computed: {
    getUser() {
      return this.$store.state.user.user;
    },
  },
  methods: {
    async handleDelete() {
      try {
        const res = await axios.delete(`/users/${this.id}`);
        console.log(res);
        this.successfulyDeleted = true;
        var self = this;
        setTimeout(function () {
          self.$router.push({ path: "/" });
        }, 3000);
        console.log(res);
      } catch (err) {
        throw new Error(err);
      }
    },
    cancelDelete() {
      this.$router.push("/");
    },
  },
};
</script>
<style lang="scss" scoped>
.userContent {
  height: 100vh;
}
</style>
